CodecVisa User Guide

Version 3.15

1 Introduction

1.1 Overview

 CodecVisa is a powerful tool designed for professionals and researchers in the video compression field. CodecVisa provides a set of unique features such as surface display in different stages and codec comparison. CodecVisa enables user to perform effective and in-depth analysis of video streams.

1.2 Supported Codecs

 CodecVisa supports following codecs:
  • H.264/AVC up to High 4:2:2 Profiles, and Multiview High/Stereo high profiles.
  • GOOGLE VP8(®)/Webm.
  • MPEG2 Video without High 4:2:2 and scalability extensions.
  • YUV(YUV400/420/422/444, 8bit).

1.3 Feature List

 Main Features for H.264/AVC/MVC
  • Profiles & Levels:
    + Baseline/Main/Extended/High/High 10/High 4:2:2/Multiview High/Stereo high profiles on all levels.
  • File formats:
    + H.264 Byte Stream format(Annex B)
    + H.264 in RTP format
    + flash flv/f4v file formats
    + MKV(Matroska Video) file formats
    + MP4/3GP/M4V file formats.
    + mpeg2 ts file format, including mpeg2 ts for ISDB-T 1seg, Blue-Ray.
  • Full Playback Mode, including :
    + Display Order Playback: Play/Pause/FF/FR/StepForward/StepBackward.
    + Decoding Order Playback: Play/Pause/FF/StepForward.
  • Full support for Data Partitions.
  • I/P/B MB insight analysis, including:
    + mb type
    + intra/inter/inter-view prediction information
    + ref list
    + Deblocking filter strength information
    + I/P/B MB mode overlay display
  • MB pixel and picture display in all decoding stages, including:
    + Finally decoded pixels
    + Pixels before Deblocking Filter
    + Predicted Pixels
    + Pixels from residual data
    + IDCT coefficients
  • Detailed statistics information
    + Bit numbers for the picture & encoding rate
    + Average MB bits & Average QP
    + MB bit histogram per mb type
    + Encoding tools detection
  • Overlay display on
    + Bit numbers for each MB
    + Block Structures
    + Motion Vectors
  • Header Information, including:
    + NALU tree
    + SPS tree
    + PPS tree
    + Slice Header tree
  • Dump decoded YUV Pixel/MB/Picture Summary into file.
  • Comparison between Other streams(YUV, H.264/AVC/MVC, VP8, MPEG2 Video)
  • Container Structure analysis on MP4/FLV/MKV/Mpeg2 TS
Main Features for VP8
  • File formats:
    + Webm/MKV file formats.
    + IVF file format.
  • Full Playback Mode, including :
    + Play/Pause/FF/FR/StepForward/StepBackward.
  • I/P/B MB insight analysis, including:
    + mb type
    + intra/inter prediction info
    + I/P MB mode overlay display
  • MB pixel and picture display in all decoding stages, including:
    + Finally decoded pixels
    + Pixels before Loop Filter
    + Predicted Pixels
    + Pixels info from residual data
    + IDCT coefficients
  • Detailed statistics information
    + Bit numbers for the picture & encoding rate
    + Average MB bits
  • Overlay display on
    + Bit numbers for each MB
    + Block Structures
    + Motion Vectors
  • Header Information, including:
    + Frame Header tree
  • Dump decoded YUV output/Pixel/MB info/Frame Header into file.
  • Comparison between Other streams(YUV, H.264/AVC/MVC, VP8, MPEG2 Video)
  • Container Structure analysis on MKV/Webm
Main Features for MPEG2 Video
  • Profiles & Levels:
    + Supports all MPEG-2 profiles/levels, excluding scalability extensions and High 4:2:2.
  • File formats:
    + mpeg2 transport stream format and program stream format.
    + MPEG-1 System Streams(ISO/IEC 11172-1)
  • Full Playback Mode, including :
    + Display Order Playback: Play/Pause/FF/FR/StepForward/StepBackward.
    + Decoding Order Playback: Play/Pause/FF/StepForward.
  • I/P/B MB insight analysis, including:
    + mb type
    + intra/inter prediction information
    + I/P/B MB mode overlay display
  • MB pixel info and picture display in all decoding stages, including:
    + Finally decoded pixels
    + Predicted Pixels
    + Pixels from residual data
  • Detailed statistics information
    + Bit numbers for the picture & encoding rate
    + Average MB bits & Average QP
    + MB bit histogram per mb type
  • Overlay display on
    + Bit numbers for each MB
    + Block Structures
    + Motion Vectors
  • Header Info, including:
    + Picture Header tree
  • Dump decoded YUV Pixel/MB/Picture Summary info into file.
  • Comparison between Other streams(YUV, H.264/AVC/MVC, VP8, MPEG2 Video)
  • Container Structure analysis on Mpeg2 TS/PS
Main Features for YUV
  • File formats:
    + YUV400/420/422/444(8bit).
  • MB(16x16) pixel
  • YUV value under cursor
  • Comparison between Other streams(YUV, H.264/AVC/MVC, VP8, MPEG2 Video)

1.4 System Requirements

 CodecVisa has the following minimum hardware and software requirements:
  • SSE-enabled x86 CPU
  • 512MB RAM
  • 20GB Hard Disk
  • Windows(®) XP/Vista/7 or Ubuntu 10.04

1.5 License and Support

 By installing, copying, or otherwise using the SOFTWARE PRODUCT or any UPDATES, you agree to be bound by the terms of the "CodecVisa'' End-User License Agreement (''EULA''). This EULA is a legal agreement between you (either an individual or a single entity) and Codecian Co. Ltd. for the "CodecVisa" software product(s) accompanying this EULA, which include(s) computer software and may include "online" or electronic documentation, associated media, and printed materials (''SOFTWARE PRODUCT'').
For further information, please contact the CodecVisa Support Team: codecvisa@codecian.com

2. Getting Started

2.1 Install CodecVisa on Windows®
  1. Download CodecVisa_Setup.exe from www.codecian.com or other mirror sites
  2. Run CodecVisa_Setup.exe
  3. Follow the onscreen instructions.

2.2 Uninstall CodecVisa on Windows®

 To uninstall CodecVisa:
  1. Click start->Program->CodecVisa->Uninstall CodecVisa
  2. Follow the onscreen instructions

2.3 Install CodecVisa on Ubuntu

 Note: CodecVisa is only tested on Ubuntu(>10.04).
  1. Download codecvisa.tar.gz from www.codecian.com or other mirror sites.
  2. Unzip the tarball using following command:
    3. tar zxf codecvisa.tar.gz
  3. Download related Qt4 libraries:
    4. sudo apt-get install libQtGui4

2.4 Remove CodecVisa on Ubuntu

 You can simply delete the folder which contains codecvisa.

2.5 Register CodecVisa

 CodecVisa has 2 kinds of license types:
  • Local license
  • Floating License
Both license types will be registered in following way:
  1. You will get a serial code after you purchase CodecVisa. Please input it in following window:

  2. You will be prompted by next dialog similar to following:

    3. Please copy and paste the information to an email, and send it to codecvisa@codecian.com
  3. With the information you send to us, a file called codecvisa.lic will be sent to you.
    4. Please put the codecvisa.lic to the same folder as CodecVisa.exe(Windows®)/codecvisa(linux) exists in your computer.

2.6 Run CodecVisa
  • On Windows®: Start->Programs->CodecVisa->CodecVisa
  • On Linux: double click codecvisa icon or run "./codecvisa&"

3. Using CodecVisa

3.1 Overview CodecVisa UI

 CodecVisa UI includes following main windows:
  • Menu bar
  • Tool bar
  • Thumbnail View
  • Video View
  • Pixel View
  • Header View
  • MB Info Window
  • Summary Window
Here is a typical CodecVisa UI:

3.2 Menu bar

 CodecVisa provides following menus:
File Menu
Open... | Open a stream file or project file.
Save Project | Save opened streams into a project file.
Quit | Exit CodecVisa.
Help Menu
User Manual | User Manual for CodecVisa.
License Information | Show license information.
About | Displays the version number and copyright statement.

3.3 Tool bar

 Here is the tool bar for CodecVisa:

There are 5 menu groups, as following:
  1. File Group, controls file open and close.
  2. Playback Group, controls playback.
  3. Option Group, controls some options, e.g overlays.
  4. Misc Group.
  5. Field Group, controls fields in interlace video.

3.3.1 Open file

Open file button( [image]) opens a new stream for analysis.
Press the triangle opens a list of recent files.

3.3.2 Save project

Save project button( [image]) saves all opened files into a project.

3.3.3 Close (all) file(s)

Close file button( [image]) will close all opened files.
Press the triangle opens a list of opened files, you can choose one file to close.

3.3.4 Delete temporary files(s)

Delete temporary file button( [image]) will delete all generated temporary files.

3.3.5 Playback

Playback is a set of buttons which controls the playback.

3.3.6 Playback order

Playback order button( [image]) enables/disables decoding order playback.

3.3.7 Rect

Rect button( [image]) enables/disables the 16x16 rectangle display on the video.

3.3.8 Grid

Grid button( [image]) enables/disables the 16x16 grid display on the video.

3.3.9 Motion Vectors

Motion Vectors button( [image]) enables/disables microblock motion vectors on the video.

3.3.10 MB Structure

MB Structure button( [image]) enables/disables microblock structure display on the video.

3.3.11 Slice Boundary

Slice Boundary button( [image]) enables/disables slice boundaries on the video.

3.3.12 Overlays

Overlays button( [image]) enables/disables overlay information on the video.
CodecVisa supports following overlay information:
  • MB Bits

  • MB Bits as color

  • MB type

3.3.13 Compare Streams

Compare Streams button( [image]) enables/disables comparison on 2 streams.
Streams are comparable if they meet following conditions:
  1. Same resolution
  2. Same bit depth on Luma and Chroma
Here is the window to select streams to compare:

3.3.14 Scale Video

Scale Video button( [image]) enables/disables video scaling to fit the display area.

3.3.15 Y/U/V Channel

Y/U/V Channel button( [image]) select a Y/U/V channel to display.
Here is a picture with Y-only option:

3.3.16 Dump Information

Dump Information button( [image]) dump information to file.
CodecVisa supports following information to dump:
  1. Decoded YUV Picture
  2. MB information
  3. Summary information

3.3.17 Container structure

CodecVisa saves container structure information for MP3, MPEG2 Transport/Program Stream, FLV, MKV/MTK/Webm files.
Container structure button( [image]) shows the structure in a tree. Here is a picture of MP4 file structure:

3.4 Header View

 CodecVisa supports following headers for H.264/AVC:
  • NALU
  • Active SPS
  • Active PPS
  • Slice Header
CodecVisa supports following headers for VP8:
  • Frame Header
Here is a picture for H.264/AVC slice header:

3.5 Pixel View

 CodecVisa displays following pixel values for H.264/AVC, VP8 and MPEG2 Video:
  • Final decoded pixel
  • Pixel before Loop-Filter
  • Predicted pixel
  • Residual pixel
  • IDCT Coefficients(Not for MPEG2 Video)
Pixel Values can be displayed in decimal or in hexadecimal values.
Here is a picture for H.264/AVC slice header with decimal values:

Here is a picture for H.264/AVC slice header with hexadecimal values:

3.6 Thumbnail View

 CodecVisa displays all decoded pictures in thumbnail view. User can easily select a picture to analyze by clicking on it.
Here is a picture of thumbnail:
If mouse cursor stops on a picture, a detailed information will be displayed in tip window:

3.7 Summary Window

 CodecVisa supports 2 types of summaries:
  • Picture Summary
  • Stream Summary
Picture summary displays information about Picture resolution, picture statistics like encoding rate, as well as MB statistics.
Here is a picture on Picture Summary:

Stream Summary displays information about the streams. Here is a picture on Stream Summary:

3.8 MB Info Window

 CodecVisa supports 3 types of MB Information:
  • MB Info(General)
  • Refference List(H.264/AVC)
  • MB Strength(H.264/AVC)
MB Info contains detailed information for the focused MB, e.g MB position, encoding type, bit number.
Here is a picture on MB Info:

3.9 Video View

 Video View displays the picture according to the option. CodecVisa supports video display for following decoding states:
  • Final decoded picture
  • Picture before Loop-Filter
  • Predicted picture
  • Residual picture
Besides pictures in those decoding stages, CodecVisa also supports pictures in different fields in streams with interlace contents.
  • Top Field
  • Bottom Field
  • Combined frame
CodecVisa also provides the functionality to bob the field for better quality check.